# Непрерывная интеграция (CI/CD) для проекта "Individual Task 1"

## Обзор

Данный проект использует CircleCI для автоматизации процессов сборки, тестирования и контейнеризации.

## Конфигурация

Конфигурация CI/CD находится в файле `.circleci/config.yml` и включает следующие этапы:

### 1. Сборка проекта

- Использует официальный образ .NET 8.0 SDK
- Восстанавливает зависимости проекта
- Выполняет сборку проекта в режиме Release

### 2. Тестирование

- Запускает программу с тестовыми данными
- Проверяет корректность вывода и результатов

### 3. Сборка и проверка Docker-образа

- Собирает Docker-образ на основе Dockerfile
- Запускает контейнер для проверки работоспособности
- Логирует вывод контейнера для анализа

## Как использовать

1. Настройте проект в CircleCI, связав его с GitHub/GitLab репозиторием
2. При каждом пуше в репозиторий автоматически будет запускаться процесс CI/CD
3. Результаты выполнения можно отслеживать в интерфейсе CircleCI

## Примечания

- Для локального тестирования CI/CD процесса можно использовать [CircleCI CLI](https://circleci.com/docs/local-cli)
- Для успешного завершения процесса необходимо, чтобы все этапы выполнялись без ошибок 