# Монорепозиторий для учебных проектов

![CircleCI](https://img.shields.io/circleci/build/github/VaX53Cdkrrz6sURP1NN7Ze/neko-fi/main)
![Docker](https://img.shields.io/badge/docker-ready-blue)

## Обзор

Этот репозиторий содержит набор проектов, реализованных как часть учебных заданий. Проекты организованы в структуру монорепозитория для удобного управления и непрерывной интеграции.

## Проекты

| Проект | Описание | Документация |
|--------|----------|--------------|
| [Individual Task 1](Individual%20Task%201/README.md) | Решение задачи 105 из Project Euler на F# | [README](Individual%20Task%201/README.md) |
| [lab 5](lab%205/README.md) | Лабораторная работа 5 по функциональному программированию | [README](lab%205/README.md) |

## Инструменты разработки

- `.NET 8.0` - платформа разработки
- `Docker` - контейнеризация
- `CircleCI` - непрерывная интеграция
- `Make` - автоматизация задач

## Быстрый старт

### Предварительные требования

- .NET 8.0 SDK
- Docker и Docker Compose
- Make (опционально)

### Установка

```bash
git clone https://git.djft.ru/darius-atlas/neko-fi.git
cd neko-fi
```

### Запуск проектов

Используйте Makefile для запуска проектов:

```bash
make help

# Запуск Individual Task 1
make run

# Запуск lab 5
make run-lab5

# Запуск в Docker
make docker-build
make docker-run

# Запуск только lab 5 в Docker
make lab5-docker-build
make lab5-docker-run
```

## CI/CD

Проект настроен для непрерывной интеграции с CircleCI. Подробная информация о процессе CI/CD доступна в [документации CircleCI](.circleci/README.md).

### Локальное тестирование CI

```bash
curl -fLSs https://raw.githubusercontent.com/CircleCI/local-cli/master/install.sh | bash

make ci-local
```

## Лицензия

MIT
